#include "opencl.h"

int main(int argc, char **argv)
{
    Matrixd kernel = gauss_filter_create(15, 2.0);
    Matrixu8 image = matrixu8_create_from_file("assets/image.png");
    matrixd_print(&kernel);

    cl_struct cl = {0};
    opencl_init(&cl, "gaussian_blur_kernel.cl");
    opencl_init_copy_host_buffers_mu8(&cl, &image, &kernel);
    opencl_load_kernel(&cl, "sobel_kernel.cl", "sobel", &cl.kernel1, &cl.program1);
    opencl_execute_image(&cl);
    opencl_read_result_image(&cl);

    return 0;
}
